------------------------------------------------------------------------
-- Arrow
------------------------------------------------------------------------

local ADDON_NAME, NPG = ...

NPG.Arrow = {}
do
   local ArrowFrame = CreateFrame("Frame")
   local Enabled = true
   
   do
      local f = ArrowFrame
      f:SetFrameStrata("LOW")
      f:SetSize(64, 64)
      f:SetPoint("CENTER")
      f:Hide()
      f.Texture = ArrowFrame:CreateTexture()
      f.Texture:SetTexture("Interface\\AddOns\\NamePlateGrid\\Media\\arrow.tga")
      f.Texture:SetAllPoints()
   end
   
   local function SetPoint(id)
      if id then
         ArrowFrame.npf = nil
         local parts = NPG.Plates:GetPlateParts(id)
         if parts then
            ArrowFrame.npf = parts.frame
         end
      end
      
      local f = ArrowFrame.npf
         if f then
         local point, relFrame
         for i = 1, f:GetNumPoints() do 
            point, relFrame, relPoint, x, y = f:GetPoint(i)
            if point == "BOTTOM" then break end
         end
         ArrowFrame:SetPoint("BOTTOM", relFrame, relPoint, x, y)
      end
   end
   
   function NPG.Arrow:Show(id)
      if Enabled then
         ArrowFrame:Show()
         ArrowFrame:ClearAllPoints()
         SetPoint(id)
      end
   end
   
   ArrowFrame:SetScript("OnUpdate", function() SetPoint() end)
   
   function NPG.Arrow:Hide()
      ArrowFrame:Hide()
   end
end